/*
Exercice 3 :
Créer en PL/SQL une procédure stockée qui permet d’afficher à l’écran les informations de chaque adhérent en indiquant pour chaque année le montant de leur cotisation et le nombre d’activités auxquelles il est inscrit.
*/

--Voir le Nota Bene en bas de page!


--1) premiere procedure qui calcule une cotisation pour une annee.
set serveroutput on
/*
Pour le calcul des factures, on reprend exactement que dans tp2_ex1, on remplace le sysdate par l'annee voulue passee en parametre, et on ajoute les autres donnees recherchees.
*/

create or replace procedure edit_fact(n number) as
--l annee desiree est passee en parametre.

cursor facturation is
		select a.numadh, nom, prenom, adresse, to_number((to_date(n, 'YYYY')-datenais)/365) age, 
			(count(*)*25) mntcotis, anneeparticipe, count(p.numact) nb_activite
		from adherent a, participe p
		where a.numadh=p.numadh
		and anneeparticipe=n
		and not exists(
			select * from intervenant i
			where i.nom=a.nom
			and i.prenom=a.prenom
			and i.adresse=a.adresse)
		group by a.numadh, nom, prenom, adresse, to_number((to_date(n, 'YYYY')-datenais)/365), anneeparticipe
		order by nom, adresse, numadh;
		--requete permettant d'obtenir les adherents concernes par la cotisation.

famille number(2);
un_an_fact_adh facturation%rowtype;	

begin

	open facturation;
		dbms_output.put_line('Cotisations pour l''annee '||n||' :');
		loop
	
			fetch facturation into un_an_fact_adh;
			
				if (un_an_fact_adh.numadh is NULL) then
					dbms_output.put_line('Aucune cotisation !');
				end if;

			exit when facturation%notfound;
/*
avant de sortir, si le champ un_an_fact_adh.numadh est NULL c'est que le curseur ne contient aucune ligne, on indique donc qu'il n'y a aucune cotisation cette annee la
*/	
				if (un_an_fact_adh.age<12) then
					un_an_fact_adh.mntcotis := un_an_fact_adh.mntcotis * 0.5;
				end if;
				--si l'adherent a moins de 12 ans, on applique une reduction de 50%
			
			select nvl(count (*),0) into famille 
			from adherent a, participe p
			where un_an_fact_adh.nom=a.nom
			and un_an_fact_adh.adresse=a.adresse
			and a.numadh=p.numadh
			and anneeparticipe=n
			and un_an_fact_adh.numadh != a.numadh;
			--on compte le nombre de membres de la meme famille que l'adherent etudie (dans unadh)
		
				if(famille !=0) then
					un_an_fact_adh.mntcotis := un_an_fact_adh.mntcotis * 0.7;
				end if;
			--si plusieurs membres d'une meme famille sont adherents, on applique une reduction de 30%


			
dbms_output.put_line('Numero d''adherent : '|| un_an_fact_adh.numadh||'. Nom prenom, adresse, age : '|| un_an_fact_adh.nom ||' '||un_an_fact_adh.prenom||', '|| un_an_fact_adh.adresse||', ' || ROUND(un_an_fact_adh.age,2) || ' ans. Nombre d''activites, montant de la cotisation : '|| un_an_fact_adh.nb_activite ||' activite(s), '||un_an_fact_adh.mntcotis||' euros.');
			
/*
on affiche les informations utiles pour le calcul de la cotisation en arrondissant l'age a deux decimales apres la virgule. 
*/
	
end loop;
	
	close facturation;	
	
end;
/



--2) seconde procedure qui appel le calcul des cotisations pour chaque annee.
create or replace procedure toutes_factures as

d number(4);
f number(4);
i number(4);

	begin
	
		select min(anneeparticipe) into d
		from participe;
		--selection de la premiere annee a partir de laquelle il y a des inscriptions
		
		select max(anneeparticipe) into f
		from participe;
		--selection de la derniere annee ou il y a des inscriptions
		
			for i in d..f loop
				edit_fact(i);
			end loop;
			--on appelle l'edition des factures pour chaque annee, entre les deux annes "bornes"
			
end;
/

		
/*
NB : avec ces deux procedures, on calcule toutes les cotisations a chaque appel de la procedure "toutes_factures". Cette methode requiert moins de places dans la  base de donnee, mais est tres peu performante. La place occupee n'etant probablement pas un probleme, il aurait sans doute ete preferable et beaucoup plus simple d'ajouter une colonne "annee" a la table facture afin de stocker directement ces donnes au fur et a mesure sans avoir a les recalculer a chaque fois.
J'ai neanmoins utilise la premiere methode car j'ai suppose que ne n'avais pas le droit de modifier la table facture.
*/
