--creation des tables :
create table T1(num number(4), nom varchar2(30));
create table T2(num number(4), nom varchar2(30));
commit;

--1) Procedure qui affiche a l'ecran le message mis en argument.
set serveroutput on

create or replace procedure affiche_mes(mes varchar2) as
begin
	dbms_output.put_line(mes);
end;
/
-- exemple d'utilisation : exec affiche_mes('hello');


--2) Procedure qui insere les valeurs mises en argument dans la table T1.
create or replace procedure inserer_enr(num number, nom varchar2) as
begin
	insert into T1 values (num, nom);
end;
/
--Exemple : exec inserer_enr(5, 'X'); va insérer une nouvelle ligne avec les valeurs 5 et X dans T1


--3) Procedure qui insere une liste de n lignes dans T1, et affiche chaque ligne ajoutee.
set serveroutput on
create or replace procedure inserer_liste(n number) as
x number;
i number;

begin

	select nvl (max(num),0) into x 
	-- On part du plus grand numero existant dans la table.
	--nvl : si ce numero est NULL (il n'y en a pas), on met 0.
	from T1;

	for i in x+1 .. x+n loop
		insert into T1 values ( i, 'AA-'||i); 
		--insertion de i dans la colonne num, puis de 'AA-"suivi de i dans la colonne nom, en partant de x+1 (=le max existant + 1)
		dbms_output.put_line('('||i||', ''AA-'||i||''')'); 
		--affichage de la ligne qui vient d'etre ajoutee.
	end loop;

end;
/
--Exemple : exec inserer_liste(5); va insérer 5 nouvelles ligne de (1, AA-1) a (5, AA-5) 



--4) Procedure qui affiche les lignes presentes dans T1.
set serveroutput on
create or replace procedure affiche_table as

	cursor c is select * from T1;
	
e T1%rowtype;
--creation d'une variable pouvant contenir une ligne du curseur c.

begin

	open c;

	loop
	
		fetch c into e;
		exit when c%notfound;
		dbms_output.put_line('('||e.num||', '''||e.nom||''')');
		
	end loop;

	close c;

end;
/
--utilisation : exec affiche_table;



--5) Procedure qui affiche les n premieres lignes, classees par numero.
set serveroutput on
create or replace procedure affiche_max(n number) as
	cursor c is 
		select * 
		from T1 
		order by num;
	--curseur qui range les lignes par numero
e T1%rowtype;
i number;

begin

	open c;

	for i in 1 .. n loop
   	fetch c into e;
		exit when c%notfound;
		dbms_output.put_line('('||e.num||', '''||e.nom||''')');
	end loop;
/*
on parcours le curseur de 1 jusqu'a n (donc n fois), l'affichage se fera dans l'ordre car le classement est fait par le curseur
*/

	close c;

end;
/
--utilisation : exec affiche_max(3);
