--1) Trigger qui affiche la valeur qui vient d'etre inseree dans T1.

set serveroutput on
create or replace trigger insere_t1
	after insert on t1 for each row

begin

		dbms_output.put_line('valeur inseree : ('||:new.num||', '''||:new.nom||''')');
		
end;
/


--2) Trigger qui affiche la valeur qui vient d'etre supprimee dans T1.
set serveroutput on
create or replace trigger efface_t1
	after delete on t1 for each row
	
begin

	dbms_output.put_line('valeur supprimee : ('||:old.num||', '''||:old.nom||''')');

end;
/


--3) Trigger qui affiche la valeur qui vient d'etre mise a jour (l'ancienne valeur et la nouvelle) dans T1.
set serveroutput on
create or replace trigger maj_t1
	after update on t1 for each row

begin

	dbms_output.put_line('valeur ('||:old.num||', '''||:old.nom||''') remplacee par ('||:new.num||', '''||:new.nom||''')');

end;
/



--4) Trigger qui se declenche a chaque modification de la table T1 pour synchroniser la table T2.
set serveroutput on
create or replace trigger Sync_table_T1
	after insert or update or delete on T1 for each row

begin

	if inserting then
		insert into T2 values (:new.num, :new.nom);
	end if;

	if updating then
		update T2 set nom=:new.nom, num=:new.num where nom=:old.nom and num=:old.num;
	end if;

	if deleting then
		delete from T2 where num=:old.num and nom= :old.nom;
	end if;

	dbms_output.put_line('table T2 synchronisee avec T1 !');

end;
/
