--1) Trigger qui empeche l'inscription d'un adherent a une activite dont il n'a pas l'age requis.

set serveroutput on
create or replace trigger age_requis

	before insert or update on participe for each row
	--le trigger se declenche avant une insertion, mise a jour ou suppression d'une ligne.

declare

nais_adh number(4);
age_req number(2);
trop_jeune exception;

begin

	select distinct to_number(to_char(datenais,'YYYY')) into nais_adh 
	from adherent, participe 
	where adherent.numadh = :new.numadh;	
	--recuperation de l annee de naissance de l adherent entre.
	
	select distinct agerequis into age_req 
	from activite, participe 
	where activite.numact = :new.numact;
	--recuperation de l'age requis pour l'activitee entree
	
	if( ( :new.anneeparticipe-nais_adh) < age_req) then
		raise trop_jeune;
		--appel de l'exception si l'age de l'adherent pour l'annee entree est inferieure a l'age requis par l'activite
	end if;

	exception
		when trop_jeune then 
			raise_application_error(-20001,'l''adherent est trop jeune pour cette activite !');
end;
/
--exemple de ligne qu'on ne peut pas inserer : insert into participe values(4,1,2005);
