set serveroutput on

create or replace procedure fact as
	cursor lesadh is
		select a.numadh, nom, prenom, adresse, ((sysdate-datenais)/365) age, (count(*)*25) mntcotis
		from adherent a, participe p
		where a.numadh=p.numadh
		and anneeparticipe=to_number(to_char(sysdate,'YYYY'))
		and not exists(
			select * from intervenant i
			where i.nom=a.nom
			and i.prenom=a.prenom
			and i.adresse=a.adresse)
		group by a.numadh, nom, prenom, adresse, (sysdate-datenais)/365
		order by nom, prenom, adresse;
/*
creation d'un curseur qui recupere tout les adherents qui participent a une activite et qui ne sont pas des intervenants, calcule leur age et le montant de leur cotisation.
*/

famille number(2);
unadh lesadh%rowtype;

begin

	open lesadh;
	--on ouvre le curseur pour s'en servir
	loop

		fetch lesadh into unadh;
		exit when lesadh%notfound;
/*
On place la ligne du curseur dans une variable, et on quitte la boucle des qu'il n'y a plus d'adherent dans le curseur
*/
			if (unadh.age<12) then
				unadh.mntcotis := unadh.mntcotis * 0.5;
			end if;
			--si l'adherent a moins de 12 ans, on applique une reduction de 50%
			
		select nvl(count (*),0) into famille 
		from adherent a, participe p
		where unadh.nom=a.nom
		and unadh.adresse=a.adresse
		and a.numadh=p.numadh
		and anneeparticipe=to_number(to_char(sysdate,  'YYYY'))
		and unadh.numadh != a.numadh;
		--on compte le nombre de membres de la meme famille que l'adherent etudie (dans unadh)
		
			if(famille !=0) then
				unadh.mntcotis := unadh.mntcotis * 0.7;
			end if;
			--si plusieurs membres d'une meme famille sont adherents, on applique une reduction de 30%
			
		insert into facture values (unadh.numadh, unadh.mntcotis);
		dbms_output.put_line(unadh.nom||' '||unadh.prenom||' - Ville : '||unadh.adresse||' - Age : '||ROUND(unadh.age,2)||' ans - Cotisation : '||unadh.mntcotis||' euros');
		--affichage du montant de la cotisation enregistre.
		
	end loop;

close lesadh;
--on ferme le curseur

end;
/




